using System;
using System.Data.SqlClient;
using System.Data;
using System.Collections;
using System.Collections.Generic;

namespace POSPrintSvr.DAL
{
    /// <summary>
    /// SqlTools SQL Server ݿỰࡣ
    /// </summary>
    public class SqlTools : IDisposable
    {
        private string SqlConnectString;
        private  SqlConnection dbConnection;
        private string error;
      
        public string ConnectString
        {
            get { return this.SqlConnectString; }
        }

        public SqlTools()
        {

        }

        public SqlTools(string strConn)
        {
            SqlConnectString = strConn;  
        }

        ~SqlTools()
        {
            Dispose();
        }

        /// <summary>
        /// dbConnectionַ
        /// </summary>
        /// <param name="strConn"></param>
        public void Setup(string strConn)
        {
            SqlConnectString = strConn;
        }

        /// <summary>
        /// dbConnectionǷ
        /// </summary>
        public bool IsOpen
        {
            get
            {
                try
                {
                    dbConnection = new SqlConnection(SqlConnectString);
                    dbConnection.Open();
                    return true;
                }
                catch
                {
                    return false;
                }
                finally
                {
                    dbConnection.Close();
                }
            }
        }

        /// <summary>
        /// ִSQL洢 ûƣ
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>Ӱ</returns>
        public int ExecSql(string sql)
        {
            int nResult = -1;
            try
            {
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (SqlCommand cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                    nResult = cmd.ExecuteNonQuery();
                }
                return nResult;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return -1;
            }
            finally
            {
                dbConnection.Close();
            }


        }

        /// <summary>
        /// ִSQL洢 ûƣ
        /// </summary>
        /// <param name="sql">SQL</param>
        /// <param name="sp">ѳʼ(ͺֵ)SqlParameter</param>
        /// <returns>-1Ϊִʧܣ-1ִгɹΪsqlִӰ</returns>
        public int ExecSql(string sql, SqlParameter[] sp)
        {
            int nResult = -1;
            try
            {
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (SqlCommand cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                    foreach (SqlParameter sqr in sp)
                    {
                        cmd.Parameters.Add(sqr);
                    }
                    nResult = cmd.ExecuteNonQuery();
                }
                return nResult;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();               
                return -1;
            }
            finally
            {
                dbConnection.Close();
            }
        }

        /// <summary>
        /// ִSQL洢 ƣ
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>Ӱ</returns>
        public int ExecSqlUsingTrans(string sql)
        {
            int nResult = -1;
            SqlTransaction st = null;
            try
            {
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                st = dbConnection.BeginTransaction();
                using (SqlCommand cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                    cmd.Transaction = st;
                    nResult = cmd.ExecuteNonQuery();
                }
                st.Commit();
                return nResult;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                st.Rollback();
                return -1;
            }
            finally
            {
                dbConnection.Close();
            }
        }

        /// <summary>
        /// ִSQL洢 SqlDataReaderķʽ
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>ݵSqlDataReader</returns>
        public SqlDataReader GetSqlDataReader(string sql)
        {
            try
            {
                SqlDataReader SDR;
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();

                using (SqlCommand cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                    SDR = cmd.ExecuteReader();
                }
                return SDR;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return null;
            }
            finally
            {
                dbConnection.Close();
            }
        }

        /// <summary>
        /// ִSQL洢 DataSetķʽ
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>ݵSqlDataReader</returns>
        public DataSet GetDataSet(string sql)
        {
            try
            {
                DataSet ds;
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (SqlDataAdapter SDA = new SqlDataAdapter(sql, SqlConnectString))
                {
                    ds = new DataSet();
                    SDA.Fill(ds);
                }
                return ds;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return null;
            }
            finally
            {
                dbConnection.Close();
            }
        }


        /// <summary>
        /// ִSQL洢 IListķʽ
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>ѳʼIList</returns>
        public IList ExcuteSQLReturnIList(string sql)
        {
            try
            {
                DataSet ds;
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (SqlDataAdapter SDA = new SqlDataAdapter(sql, SqlConnectString))
                {
                    ds = new DataSet();
                    SDA.Fill(ds);
                }
                return ds.Tables[0].DefaultView as IList;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return null;
            }
            finally
            {
                dbConnection.Close();
            }
        }

        /// <summary>
        /// ִSQL ݼһеһ 
        /// </summary>
        /// <param name="sql">SQL</param>
        /// <returns>ݼĵһеһ</returns>
        public object ExecuteScalar(string sql)
        {
            object nResult = null;
            try
            {
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (SqlCommand cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                    nResult = cmd.ExecuteScalar();
                }
                return nResult;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return nResult;
            }
            finally
            {
                dbConnection.Close();
            }
        }

        /// <summary>
        /// SQL ѳʼSqlCommand (sqlĲȽϸӵ¡output ͵)
        /// </summary>
        /// <param name="sql">SQL䣨ԤѾƴSQL淶</param>
        /// <returns>ѳʼSqlCommand</returns>
        public SqlCommand GetSqlCommand(string sql)
        {
            SqlCommand cmd = null;
            try
            {
                dbConnection = new SqlConnection(SqlConnectString);
                dbConnection.Open();
                using (cmd = dbConnection.CreateCommand())
                {
                    cmd.CommandText = sql;
                }
                return cmd;
            }
            catch (Exception ex)
            {
                error = ex.Message.ToString();
                return null;
            }
        }

        /// <summary>
        /// ȡһδ
        /// </summary>
        /// <returns></returns>
        public string GetLastError()
        {
            return error;
        }

        #region IDisposable Ա

        public void Dispose()
        {
            // TODO:   SqlTools.Dispose ʵ
            if (dbConnection != null)
            {
                dbConnection.Dispose();

                dbConnection = null;
            }
        }

        #endregion
    }
}
