using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using POSPrintSvr.DAL;
using System.Data.SqlClient;

namespace PrintServiceMgr
{
    public partial class CookRoomSetForm : Form
    {
        PosPrintSvrSet setting = new PosPrintSvrSet();
        private DataSet dsCookRoom;
        private SqlConnection conn;
        SqlDataAdapter adapter;
        public CookRoomSetForm()
        {
            InitializeComponent();
            dataGridView1.AutoGenerateColumns = false;
        }

        private void CookRoomSetForm_Load(object sender, EventArgs e)
        {
            setting.ReadSeting();
            numSleepTimeLen.Value = int.Parse(setting.GetSleepTimeLen()) / 1000;
            numMaxReq.Value = decimal.Parse(setting.GetMaxQuqueNum());
            rbYes.Checked = (setting.GetIsWriteLog() == "Y");
            textConnStr.Text = setting.GetDbConnStr();
            //ݿַǷ
            SqlTools dbTools = new SqlTools(textConnStr.Text.Trim());
            if (dbTools.IsOpen)
            {                
                conn = new SqlConnection(textConnStr.Text.Trim());
                adapter = new SqlDataAdapter("select * from CookRooms",conn);
                SqlCommandBuilder builder = new SqlCommandBuilder(adapter);
                builder.QuotePrefix = "[";
                builder.QuoteSuffix = "]";
                SqlCommand cmd = new SqlCommand("Delete CookRooms Where CookRoomNo = @CookRoomNo",conn);
                SqlParameter para = new SqlParameter("@CookRoomNo",SqlDbType.VarChar,3);
                cmd.Parameters.Add(para);
                adapter.DeleteCommand = cmd;
                dsCookRoom = new DataSet();
                conn.Open();
                adapter.Fill(dsCookRoom, "CookRooms");       
                dataGridView1.DataSource=dsCookRoom.Tables[0];
                conn.Close();
            }
        }

        private void btSavePara_Click(object sender, EventArgs e)
        {
            setting.SetDbConnStr(textConnStr.Text.Trim());
            if (rbYes.Checked)
                setting.SetIsWriteLog("Y");
            else setting.SetIsWriteLog("N");
            decimal sleepLen=numSleepTimeLen.Value * 1000;
            setting.SetSleepTimeLen(sleepLen.ToString());
            setting.SetMaxQuqueNum(numMaxReq.Value.ToString());
            setting.SaveSeting();
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btAdd_Click(object sender, EventArgs e)
        {
            DataRow dr = dsCookRoom.Tables[0].NewRow();
            int rowIndex = 1000 + dsCookRoom.Tables[0].Rows.Count + 1;
            dr[0] = rowIndex.ToString().Substring(1, 3);
            dr[1] = "³Ʒ";
            dr["SysFlag"] = "N";
            dsCookRoom.Tables[0].Rows.Add(dr);
        }

        private void btDel_Click(object sender, EventArgs e)
        {
            object obj_Exists = DbOperate.dbOperate.dbTools.ExecuteScalar(string.Format("select count(*) from MenuPrintRequest "+
                                                                          " where PrintFlag='N' and CookRoomNo = '{0}'", dataGridView1["ColCookRoomNo",dataGridView1.CurrentRow.Index].Value.ToString()));
            if (obj_Exists != null)
            {
                if (int.Parse(obj_Exists.ToString()) > 0)
                {
                    MessageBox.Show(string.Format("Ʒ'{0}'Ѿʹãɾ", 
                                    dataGridView1["ColCookRoomName",dataGridView1.CurrentRow.Index].Value.ToString()),
                                    "ϵͳʾ");
                    return;
                }
            }
            if (dataGridView1.CurrentRow != null)
            {                
                obj_Exists = null;
                obj_Exists = DbOperate.dbOperate.dbTools.ExecuteScalar(string.Format("select count(*) from CookRooms where CookRoomNo = '{0}'",
                                                                      dataGridView1["ColCookRoomNo",dataGridView1.CurrentRow.Index].Value.ToString()));
                if (obj_Exists != null)
                {
                    if (int.Parse(obj_Exists.ToString()) > 0)
                    {
                        if (MessageBox.Show(string.Format("ǷɾƷ'{0}'",
                                           dataGridView1["ColCookRoomName",dataGridView1.CurrentRow.Index].Value.ToString()),"ȷϣ",
                                           MessageBoxButtons.YesNo,
                                            MessageBoxIcon.Question,
                                           MessageBoxDefaultButton.Button1) == DialogResult.Yes)
                        {
                            adapter.DeleteCommand.Parameters[0].Value = dataGridView1["ColCookRoomNo", dataGridView1.CurrentRow.Index].Value.ToString();
                            conn.Open();
                            adapter.DeleteCommand.ExecuteNonQuery();
                            dsCookRoom.Tables[0].Rows.RemoveAt(dataGridView1.CurrentRow.Index);
                            adapter.Update(dsCookRoom.Tables[0]);
                            conn.Close();
                            return;
                        }                        
                    }
                }
                dsCookRoom.Tables[0].Rows.RemoveAt(dataGridView1.CurrentRow.Index);
            }
        }

        private void btSave_Click(object sender, EventArgs e)
        {
            conn.Open();
            adapter.Update(dsCookRoom.Tables[0]);
            conn.Close();
            MessageBox.Show("ɹ","ϵͳʾ");
        }
    }
}