using System;
using System.Management;
using System.Net;
using System.IO;
using System.Net.NetworkInformation;

namespace PrintServiceMgr
{
    /// <summary>
    /// ȡؼӲϢ
    /// </summary>
    public class LocalComputerInfo
    {
        public static LocalComputerInfo LocalPC_Info = new LocalComputerInfo();
        public string CpuID; //1.cpuк
        public string MacAddress; //2.macк
        public string DiskID; //3.Ӳid
        public string IpAddress; //4.ipַ
        public string LoginUserName; //5.¼û
        public string ComputerName; //6.
        public string SystemType; //7.ϵͳ
        public string TotalPhysicalMemory; //8.ڴ λM 
        public string LanPublicIPAddress
        {
            get { return GetLanInternetStatus(); }
        }

        public LocalComputerInfo()
        {
            CpuID = GetCpuID();
            MacAddress = GetMacAddress();
            DiskID = GetDiskID();
            IpAddress = GetIPAddress();
            LoginUserName = GetUserName();
            SystemType = GetSystemType();
            TotalPhysicalMemory = GetTotalPhysicalMemory();
            ComputerName = GetComputerName();
        }
     
        /// <summary>
        /// 1.ȡCPUкŴ 
        /// </summary>
        /// <returns></returns>
        private string GetCpuID() 
        { 
            try 
            { 
                 string cpuInfo = "";//cpuк 
                ManagementClass mc = new ManagementClass("Win32_Processor"); 
                ManagementObjectCollection moc = mc.GetInstances(); 
                foreach (ManagementObject mo in moc) 
                { 
                    cpuInfo = mo.Properties["ProcessorId"].Value.ToString(); 
                } 
                moc = null; 
                mc = null; 
                return cpuInfo; 
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 

        } 
 
        /// <summary>
        /// 2.ȡӲַ
        /// </summary>
        /// <returns></returns>
        private string GetMacAddress() 
        { 
            try 
            { 
                 string mac = ""; 
                ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration"); 
                ManagementObjectCollection moc = mc.GetInstances(); 
                foreach (ManagementObject mo in moc) 
                { 
                    if ((bool)mo["IPEnabled"] == true) 
                    { 
                        mac = mo["MacAddress"].ToString(); 
                        break; 
                    } 
                } 
                moc = null; 
                mc = null; 
                return mac; 
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 

        } 
 
        /// <summary>
        /// 3.ȡӲID 
        /// </summary>
        /// <returns></returns>
        private string GetDiskID() 
        { 
            try 
            { 
                 String HDid = ""; 
                ManagementClass mc = new ManagementClass("Win32_DiskDrive"); 
                ManagementObjectCollection moc = mc.GetInstances(); 
                foreach (ManagementObject mo in moc) 
                { 
                    HDid = (string)mo.Properties["Model"].Value; 
                } 
                moc = null; 
                mc = null; 
                return HDid; 
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 

        } 
 
        /// <summary>
        /// 4.ȡIPַ
        /// </summary>
        /// <returns></returns>
        private string GetIPAddress() 
        { 
            try 
            { 
                string st = ""; 
                ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration"); 
                ManagementObjectCollection moc = mc.GetInstances(); 
                foreach (ManagementObject mo in moc) 
                { 
                    if ((bool)mo["IPEnabled"] == true) 
                    { 
                        //st=mo["IpAddress"].ToString(); 
                        System.Array ar; 
                        ar = (System.Array)(mo.Properties["IpAddress"].Value); 
                        st = ar.GetValue(0).ToString(); 
                        break; 
                    } 
                } 
                moc = null; 
                mc = null; 
                return st; 
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 

        } 


        /// <summary>
        /// 5.ϵͳĵ¼û
        /// </summary>
        /// <returns></returns>
        private string GetUserName() 
        { 
            try 
            { 
                 return Environment.UserName;                            
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 

        } 



        /// <summary>
        /// 6.ȡ
        /// </summary>
        /// <returns></returns>
        private  string GetComputerName() 
        { 
            try 
            { 
                return System.Environment.MachineName;
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 
        } 
        
        /// <summary>
        /// 7 PC OS
        /// </summary>
        /// <returns></returns>
        private string GetSystemType() 
        { 
            try 
            { 
                string st = ""; 
                ManagementClass mc = new ManagementClass("Win32_ComputerSystem"); 
                ManagementObjectCollection moc = mc.GetInstances(); 
                foreach (ManagementObject mo in moc) 
                { 

                    st = mo["SystemType"].ToString(); 

                } 
                moc = null; 
                mc = null; 
                return st; 
            } 
            catch 
            { 
                return "unknow"; 
            } 
            finally 
            { 
            } 
        } 
        

        /// <summary>
        /// 8.ڴ
        /// </summary>
        /// <returns></returns>

        private string GetTotalPhysicalMemory()
        {
            try
            {

                string st = "";
                ManagementClass mc = new ManagementClass("Win32_ComputerSystem");
                ManagementObjectCollection moc = mc.GetInstances();
                foreach (ManagementObject mo in moc)
                {

                    st = mo["TotalPhysicalMemory"].ToString();

                }
                moc = null;
                mc = null;
                return st;
            }
            catch
            {
                return "";
            }
        }


        /// <summary>
        /// þIP
        /// </summary>
        /// <returns></returns>
        public String GetLanPublicIP()
        {
            Uri uri = new Uri("http://www.ip138.com/ip2city.asp");
            WebRequest wr = WebRequest.Create(uri);
            string ip = string.Empty;
            try
            {
                Stream s = wr.GetResponse().GetResponseStream();
                if (s != null)
                {
                    StreamReader sr = new StreamReader(s, System.Text.Encoding.Default);
                    string all = sr.ReadToEnd(); //ȡվ
                    int i = all.IndexOf("[") + 1;
                    string tempip = all.Substring(i, 15);
                    string[] tempstr = tempip.Split("]".ToCharArray());
                    if (tempstr.Length > 0)
                        ip = tempstr[0];                   
                    sr.Close();
                }
                else
                {
                    s.Flush();
                    s.Close();
                }
            }
            catch (Exception ex)
            {
                ip = string.Empty;
            }
            wr.Abort();            
            return ip;
        }

        /// <summary>
        /// pingһ¿С,ٷؾIP
        /// </summary>
        /// <returns></returns>
        private string GetLanInternetStatus()
        {
            Ping p = new Ping();
            try
            {
                PingReply pingResult = p.Send("www.ip138.com", 1000);
                if (pingResult == null) return string.Empty;
                if (pingResult.Address != null)
                    return "CRS System Online!";
                else return string.Empty;
            }
            catch 
            {
                return string.Empty;
            }          
        }
    }
}
