using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceProcess;
using System.Collections;
using Microsoft.Win32;
using System.Configuration.Install;
using POSPrintSvr.DAL;
using System.Threading;
namespace PrintServiceMgr
{
    public partial class PrintSvrMgrFrm : Form
    {
        ServiceController scer = new ServiceController();
        Hashtable hs = new Hashtable();
        bool canClose = false;
        public PrintSvrMgrFrm()
        {
            InitializeComponent();
        }

        private void PrintSvrMgrFrm_Load(object sender, EventArgs e)
        {
            this.lbl_computerName.Text =
             LocalComputerInfo.LocalPC_Info.ComputerName.Trim();
            //ȡشӡ
            ServiceController[] scs = ServiceController.GetServices();
            foreach (ServiceController sc in scs)
            {
                hs.Add(sc.ServiceName, sc);
                if (sc.ServiceName == "PosPrintService")
                {
                    this.cbx_services.Items.Add(sc.ServiceName);
                    scer = sc;
                    this.cbx_services.SelectedItem = sc.ServiceName;
                    break;
                }
            }
            if (cbx_services.Items.Count == 0)
            {
                SetUpSMSService();
                Resfresh();
            }
        }

        private void Resfresh()
        {
            ServiceController[] services = ServiceController.GetServices();
            cbx_services.Items.Clear();

            foreach (ServiceController SvrController in (services))
            {
                if (SvrController.ServiceName == "PosPrintService")
                {
                    if (!hs.Contains(SvrController.ServiceName))
                        hs.Add(SvrController.ServiceName, SvrController);
                    cbx_services.Items.Add(SvrController.ServiceName);
                    cbx_services.SelectedItem = SvrController.ServiceName;

                    if (SvrController.Status == ServiceControllerStatus.Running
                        || scer.Status == ServiceControllerStatus.StartPending
                        )
                    {
                        this.btn_start.Enabled = false;
                        this.btn_pause.Enabled = true;
                        this.btn_stop.Enabled = true;
                    }

                    if (SvrController.Status == ServiceControllerStatus.Paused
                       || scer.Status == ServiceControllerStatus.PausePending)
                    {
                        this.btn_start.Enabled = true;
                        this.btn_pause.Enabled = false;
                        this.btn_stop.Enabled = true;
                    }

                    if (SvrController.Status == ServiceControllerStatus.Stopped
                        || scer.Status == ServiceControllerStatus.StopPending)
                    {
                        this.btn_start.Enabled = true;
                        this.btn_pause.Enabled = false;
                        this.btn_stop.Enabled = false;
                    }
                    break;
                }
            }
        }

        private void btn_start_Click(object sender, EventArgs e)
        {
            //ʼ/
            try
            {
                ServiceController scer =
                      hs[cbx_services.SelectedItem.ToString()] as ServiceController;
                if (btn_pause.Enabled == false && btn_pause.Enabled != false)
                {
                    scer.Continue();
                }

                if (btn_stop.Enabled == false && btn_pause.Enabled == false)
                {
                    scer.Start();
                }
                Resfresh();
                cbx_services_SelectedIndexChanged(this, null);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btn_pause_Click(object sender, EventArgs e)
        {
            //ͣ
            try
            {
                ServiceController scer =
                      hs[this.cbx_services.Text.Trim()] as ServiceController;
                scer.Pause();
                Resfresh();
                cbx_services_SelectedIndexChanged(this, null);                
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            //ֹͣ
            try
            {
                ServiceController scer =
                      hs[this.cbx_services.Text.Trim()] as ServiceController;
                scer.Stop();
                Resfresh();
                cbx_services_SelectedIndexChanged(this, null);              
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void cbx_services_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.cbx_services.Items.Count > 0)
            {
                if (this.cbx_services.Text.Trim() == "") { return; }
                ServiceController scer =
                    hs[this.cbx_services.Text.Trim()] as ServiceController;

                if (scer.Status == ServiceControllerStatus.Running
                    || scer.Status == ServiceControllerStatus.StartPending
                    )
                {
                    this.btn_start.Enabled = false;
                    this.btn_pause.Enabled = true;
                    this.btn_stop.Enabled = true;                   
                }

                if (scer.Status == ServiceControllerStatus.Paused
                   || scer.Status == ServiceControllerStatus.PausePending)
                {
                    this.btn_start.Enabled = true;
                    this.btn_pause.Enabled = false;
                    this.btn_stop.Enabled = true;
                }

                if (scer.Status == ServiceControllerStatus.Stopped
                    || scer.Status == ServiceControllerStatus.StopPending)
                {
                    this.btn_start.Enabled = true;
                    this.btn_pause.Enabled = false;
                    this.btn_stop.Enabled = false;
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            cbx_services_SelectedIndexChanged(null,null);
        }

        private void SetUpSMSService()
        {
            AssemblyInstaller myAssemblyInstaller;
            myAssemblyInstaller = new AssemblyInstaller();
            myAssemblyInstaller.UseNewContext = true;
            myAssemblyInstaller.Path = Application.StartupPath + @"\PosPrintService.exe";
            System.Collections.Hashtable mySavedState = new System.Collections.Hashtable();
            myAssemblyInstaller.Install(mySavedState);
            myAssemblyInstaller.Commit(mySavedState);
            myAssemblyInstaller.Dispose();
        }

        private void UnSetUpSMSService()
        {
            AssemblyInstaller myAssemblyInstaller;
            myAssemblyInstaller = new AssemblyInstaller();
            myAssemblyInstaller.UseNewContext = true;
            myAssemblyInstaller.Path = Application.StartupPath + @"\PosPrintService.exe";
            System.Collections.Hashtable mySavedState = new System.Collections.Hashtable();
            myAssemblyInstaller.CommandLine = new string[1] { "/u" };
            myAssemblyInstaller.Uninstall(null);
            myAssemblyInstaller.Dispose();
        }

        private void ˳EToolStripMenuItem_Click(object sender, EventArgs e)
        {
            canClose = true;
            this.Close();
        }

        private void PrintSvrMgrFrm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = !canClose;
            WindowState = FormWindowState.Minimized;
            timer1.Enabled = false;
            this.Visible = false;
            this.notifyIcon.Visible = true;
            this.notifyIcon.ShowBalloonTip(8);
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            this.Visible = true;
            if (this.WindowState == FormWindowState.Minimized)
            {
                this.WindowState = FormWindowState.Normal;
            }
            timer1.Enabled = true;
        }

        private void AToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show(" Email:waterwan@longtx.com","ϵͳ");
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Resfresh();
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {            
            CookRoomSetForm setFrm = new CookRoomSetForm();
            if (setFrm.ShowDialog() == DialogResult.OK)
            {
                //
            }          
        }

        private void toolStripMenuItem5_Click(object sender, EventArgs e)
        {
            new SystemLogViewForm().ShowDialog();
        }
    }
}