using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PrintServiceMgr
{
    public partial class SystemLogViewForm : Form
    {
        public SystemLogViewForm()
        {
            InitializeComponent();
            LoadLogInfor();
        }

        private void LoadLogInfor()
        {
            if (Directory.Exists(AppDomain.CurrentDomain.BaseDirectory + "Log"))
            {
                string[] files = Directory.GetFiles(AppDomain.CurrentDomain.BaseDirectory + "Log");
                tabControl1.TabPages.Clear();
                foreach (string file in files)
                {
                    StreamReader sr = new StreamReader(file,Encoding.UTF8);
                    string data = sr.ReadToEnd();
                    TabPage newPage = new TabPage();
                    newPage.Tag = file;
                    string[] tmp = file.Split(@"\".ToCharArray());
                    newPage.Text = tmp[tmp.Length-1];
                    TextBox tb = new TextBox();
                    tb.Text = data;
                    tb.Multiline = true;
                    tb.Dock = DockStyle.Fill;
                    newPage.Controls.Add(tb);
                    tabControl1.TabPages.Add(newPage);
                    sr.Close();
                }
            }            
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btClearFile_Click(object sender, EventArgs e)
        {
            if (tabControl1.TabPages.Count == 0) return;
            if (MessageBox.Show(string.Format("Ƿɾ־ļ'{0}'",
                                              tabControl1.SelectedTab.Text.Trim()),
                                "ϵͳʾ",
                                MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                File.Delete(tabControl1.SelectedTab.Tag.ToString());
                tabControl1.TabPages.Remove(tabControl1.SelectedTab);
                if (tabControl1.TabPages.Count > 0)
                    tabControl1.SelectedIndex = 0;
            }
        }
    }
}